/* BOTTOOLS.C  actually a muchly-trimmed copy of it */

struct termios orcus_term;
struct termios saved_term;

int sttyinputset(void)
{
  /* Make sure we have stdin */
  if(isatty(STDIN_FILENO) == 0)
  {
    perror("stdin is not a terminal device");
    return(1);
  }

  if(tcgetattr(STDIN_FILENO, &orcus_term) < 0)
  {
    perror("tcgetattr error");
    return(1);
  }

  /* make a copy of the term settings and store them away */
  memcpy (&saved_term, &orcus_term, sizeof(orcus_term));

#if defined SYSV || defined __OpenBSD__ 

 orcus_term.c_lflag &= ~(ECHO);
 orcus_term.c_lflag &= ~(ICANON);
 orcus_term.c_cc[VTIME] = 0;
 orcus_term.c_cc[VEOF]  = 1;
 tcsetattr(STDIN_FILENO, TCSAFLUSH, &orcus_term );

#else /* BSD */
 orcus_term.sg_flags |=  (CBREAK);
 orcus_term.sg_flags &= ~(ECHO);

#endif
}

int sttyinputreset(void) 
{
  if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &saved_term) < 0)
  {
    perror("tcgetattr error");
    return(1);
  }

}

int fdpoll(fd)

int fd; 

{
  int retval;
  ioctl ( fd, FIONREAD, &retval );
  return retval;
  }
