#include "readln.c"

void alstrcpy ( dest, src ) char **dest, *src; {
  int sz;
  sz    = strlen ( src ) + 1;
  *dest = (char*) malloc ( sz );
  strcpy ( *dest, src );
  }

char *nibble ( buf, n ) char *buf; int n; {
  int   x, i, j, k;
  int   beginning, ending;
  char *retval;

  k = strlen ( buf );
  for ( j = 0; ( j < k ) && ( buf[j] == ' ' ); j++ );
  if  ( j >= k ) return NULL;
  x = j;
  for ( i = 0; ( i < n ) && ( x < k ); i++ ) {
    while ( ( buf[x] != ' ' ) && ( x < k ) ) x++;
    while ( ( buf[x] == ' ' ) && ( x < k ) ) x++;
    }
  if ( x >= k ) return NULL;
  beginning = x;
  while ( ( buf[x] != ' ' ) && ( x < k ) ) x++;
  ending = x;
  retval = (char*) malloc ( ending - beginning + 1 );
  strncpy ( retval, buf + beginning, ending - beginning );
  retval[ending-beginning] = 0;
  return retval;
  }

char *gobble ( buf, n ) char *buf; int n; {
  int   x, i, j, k;
  int   beginning, ending;
  char *retval;

  k = strlen ( buf );
  for ( j = 0; ( j < k ) && ( buf[j] == ' ' ); j++ );
  if  ( j >= k ) return NULL;
  x = j;
  for ( i = 0; ( i < n ) && ( x < k ); i++ ) {
    while ( ( buf[x] != ' ' ) && ( x < k ) ) x++;
    while ( ( buf[x] == ' ' ) && ( x < k ) ) x++;
    }
  if ( x >= k ) return NULL;
  beginning = x;
  ending    = k;
  retval = (char*) malloc ( ending - beginning + 1 );
  strncpy ( retval, buf + beginning, ending - beginning );
  retval[ending-beginning] = 0;
  return retval;
  }

void nab_one ( buf, n, dest ) char *buf; int n; char *dest; {
  char *foo;
  if ( dest ) dest[0] = 0;
  foo = nibble ( buf, n );
  if ( foo == NULL ) { DB printf ("ARGH! 1\n"); return; }
  if ( dest == NULL ) alstrcpy ( &bigbuf, foo );
  else strcpy ( dest, foo );
  free ( foo );
  }

void nab_rest ( buf, n, dest ) char *buf; int n; char *dest; {
  char *foo;
  if ( dest ) dest[0] = 0;
  foo = gobble ( buf, n );
  if ( foo == NULL ) { DB printf ("ARGH! 2\n"); return; }
  if ( dest == NULL ) alstrcpy ( &bigbuf, foo );
  else strcpy ( dest, foo );
  free ( foo );
  }

int analyze_input_string ( buf ) /* puts parts into stuff[] */  
  char *buf;  { 
  char  foo[64];
  char *bar;
  int   i;

#ifdef DEBUG
#undef DEBUG
#endif
#define DEBUG 0

  DB printf ("analyze: alpha %d\n", (long) buf );
  if ( !buf[0] ) return 0;

  DB printf ("analyze: beta\n");
  if ( bigbuf != NULL ) {
    DB printf ("analyze: gamma\n");
    free ( bigbuf );  /* zzapp - replace this with safe free */
    DB printf ("analyze: delta\n");
    bigbuf = NULL;
    }

  DB printf ("analyze: epsilon\n");
  if ( buf[1] != '/' ) if ( buf[0] == '/' ) {
    DB printf ("analyze: iota\n");
    bar = nibble ( buf, 0 );
    if ( bar == NULL ) return 0;
    strcpy ( foo, bar );
    free ( bar );

    if ( !strcmp ( foo, "/m" ) ) {
        DB printf ("analyze: iota-1, bigbuf is %u\n", (long) bigbuf );
        nab_one  ( buf, 1, stuff[0] );
        DB printf ("analyze: iota-2, bigbuf is %u\n", (long) bigbuf );
        nab_rest ( buf, 2, bigbuf );
        return 2;
        }

    if (!strcmp(foo,"/write")){
       nab_one  ( buf, 1, stuff[0] );
       nab_rest ( buf, 2, bigbuf );
       return 20;
    }

    if (!strcmp(foo,"/read")){
       nab_one  ( buf, 1, stuff[0] );
       return 6;
    }

    if ( !strcmp ( foo, "/g" ) ) {
        nab_one ( buf, 1, stuff[0] );
        return 7;
        }

    if ( !strcmp ( foo, "/echo" ) ) {
	strcpy( stuff[0], "echoback" );
	nab_one ( buf, 1, stuff[1] );
      return 4;
      }

    if ( !strcmp ( foo, "/w" ) ) {
        stuff[0][0] = 'w';
        stuff[0][1] = 0;
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/boot" ) ) {
        strcpy ( stuff[0], "boot" );
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/beep" ) ) {
        strcpy ( stuff[0], "beep" );
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( ( !strcmp ( foo, "/keepalive" ) ) ||
         ( !strcmp ( foo, "/noidle"    ) ) ||
         ( !strcmp ( foo, "/idle"      ) )    ) {
        noidle = !noidle;
        if ( noidle ) 
          printf ("[=Idle=] keeping connection alive\n");
        else 
          printf ("[=Idle=] will let connection timeout\n");
        return 0;
        }

    if ( ( !strcmp ( foo, "/?" ) ) ||
         ( !strcmp ( foo, "/h" ) ) ||
         ( !strcmp ( foo, "/help" ) ) ) {
        printf ("/m       Send private message\n");
        printf ("/g       Go to a group\n");
        printf ("/w       List who is in the group\n");
        printf ("/boot    Boot someones ass outta there\n");
        printf ("/beep    Beep someone\n");
        printf ("/keepalive  Toggle noidle\n");
        printf ("/drop    Drop an idle connection (yours)\n");
        printf ("/p       Set your password\n");
        printf ("/name    Set your name\n");
        printf ("/nick    Set your name\n");
        printf ("/notify  Be informed of when someones online\n");
        printf ("/topic   Set the topic\n"); 
        printf ("/bmsg    Toggle beep messages\n");
        printf ("/bret    Toggle beep return messages\n");
        printf ("/hush    Hush someone\n");
        printf ("/unhush  Unhush someone\n");
        printf ("/status  Change group status\n");
        printf ("/exclude Prevent a user from seeing your message\n");
        printf ("/nobeep  Toggle beeps\n");
        printf ("/pass    Pass the modship\n");
        printf ("/cols    Set display columns (0 for infinite)\n");
        printf ("/rows    Set display rows (0 for infinite)\n");
	printf ("/write nick message   write message\n");
	printf("/read 	  read saved message");
        printf ("/q       Quit\n"); 
        return 0;
        }

    if ( !strcmp ( foo, "/drop" ) ) {
        strcpy ( stuff[0], "drop" );
        nab_one ( buf, 1, stuff[1] );
        return 3;
        }

    if ( !strcmp ( foo, "/p" ) ) {
        strcpy ( stuff[0], "p" );
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/name" ) ) {
        strcpy ( stuff[0], "name" );
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/nick" ) ) {
        strcpy ( stuff[0], "name" );
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/notify" ) ) {
        strcpy ( stuff[0], "notify" );
        nab_one ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/topic" ) ) {
        strcpy ( stuff[0], "topic" );
        nab_rest ( buf, 1, stuff[1] );
        return 4;
        }

    if ( !strcmp ( foo, "/bmsg" ) ) {
        nab_one ( buf, 1, (char *) 1 );
        if ( !strcmp ( stuff[1], "on"  ) ) { 
           bmessage = 1; 
           printf ("[=Set=] /beep messages displayed when /nobeep is on\n");
           return 0; 
           }
        if ( !strcmp ( stuff[1], "off" ) ) {
           bmessage = 0; 
           printf ("[=Set=] /beep messages ignored when /nobeep is on\n");
           return 0; 
           }
        bmessage = !bmessage;
        if ( bmessage ) 
             printf ("[=Set=] /beep messages displayed when /nobeep is on\n");
        else printf ("[=Set=] /beep messages ignored when /nobeep is on\n");
        return 0;
        }

    if ( !strcmp ( foo, "/bret" ) ) {
        nab_one ( buf, 1, (char *) 1 );
        if ( !strcmp ( stuff[1], "on"  ) ) { 
           breturn = 1; 
           printf ("[=Set=] senders of ignored /beeps informed\n");
           return 0; 
           }
        if ( !strcmp ( stuff[1], "off" ) ) {
           breturn = 0; 
           printf ("[=Set=] senders of ignored /beeps remain unclued\n");
           return 0; 
           }
        breturn = !breturn;
        if ( breturn ) 
             printf ("[=Set=] senders of ignored /beeps informed\n");
        else printf ("[=Set=] senders of ignored /beeps remain unclued\n");
        return 0;
        }

    if ( !strcmp ( foo, "/hush" ) ) {
        printf ("[=Reminder=] tell the programmer to implement /hush\n");
        return 0;
        }

    if ( !strcmp ( foo, "/unhush" ) ) {
        printf ("[=Reminder=] tell the programmer to implement /unhush\n");
        return 0;
        }

    if ( !strcmp ( foo, "/status" ) ) {
        printf ("[=Reminder=] tell the programmer to implement /status\n");
        return 0;
        }

    if ( !strcmp ( foo, "/exclude" ) ) {
        strcpy ( stuff[0], "exclude" );
        nab_one  ( buf, 1, stuff[1] );
        nab_rest ( buf, 2, stuff[2] );
        return 3;
        }

    if ( !strcmp ( foo, "/nobeep" ) ) {
        nab_one ( buf, 1, (char *) 1 );
        if ( !strcmp ( stuff[1], "on"  ) ) { 
           nobeep = 1; 
           printf ("[=Set=] nobeep is on\n");
           return 0; 
           }
        if ( !strcmp ( stuff[1], "off" ) ) {
           nobeep = 0; 
           printf ("[=Set=] nobeep is off\n");
           return 0; 
           }
        nobeep = !nobeep;
        if ( nobeep ) printf ("[=Set=] nobeep is on\n");
        else printf ("[=Set=] nobeep is off\n");
        return 0;
        }

    if ( !strcmp ( foo, "/pass" ) ) {
        nab_one ( buf, 1, stuff[0] );
        return 9;
        }

    if ( !strcmp ( foo, "/cols" ) ) {
        stuff[0][0] = 0;
        nab_one ( buf, 1, stuff[0] );
        cols = 0;
        for ( i = 0; stuff[0][i]; i++ ) {
          cols *= 10;
          cols += stuff[0][i] - '0';
	  }
        if ( cols !=   0 ) if ( cols < 23 ) cols = 23;
        if ( cols >  240 ) cols = 0;
        printf ("[=Set=] columns set to %d\n", cols );
        return 0;
        }

    if ( !strcmp ( foo, "/rows" ) ) {
        stuff[0][0] = 0;
        nab_one ( buf, 1, stuff[0] );
        rows = 0;
        for ( i = 0; stuff[0][i]; i++ ) {
          rows *= 10;
          rows += stuff[0][i] - '0';
	  }
        if ( rows !=   0 ) if ( rows < 2 ) rows = 2;
        printf ("[=Set=] rows set to %d\n", rows );
        return 0;
        }

    if ( !strcmp ( foo, "/q" ) ) return 99;
    return 0;
    } /* end of if */

  DB printf ("analyze: kappa\n");
  if ( buf[0] == '/' ) alstrcpy ( &bigbuf, buf+1 );
  else alstrcpy ( &bigbuf, buf );
  DB printf ("analyze: lambda\n");
  return 1;

#ifdef DEBUG
#undef DEBUG
#endif
#define DEBUG 0

  } /* end of function */

/* no longer used, included from readln.c 
readln ( buf ) char *buf; {
  char shut   = ' ';
  int  i      = 0;
  char bup[3] = { 8, ' ', 8 };

  while ( shut != '\n' ) {
    read  ( 0, &shut, 1 );
    switch ( shut ) {
      case '\n' : buf[i] = 0;
                  write ( 1, "\n", 1 );
                  break;
      case  21  : while ( i > 0 ) {
                    i--; 
                    write ( 1, bup, 3 );
                    }
                  break;
      case   8  : if ( i > 0 ) {
                    i--; 
                    write ( 1, bup, 3 );
                    }
                  break;
      default   : if ( ( shut < ' ' ) || ( shut > '~' ) ) break;
                  buf[i] = shut;
                  write ( 1, &shut, 1 );
                  i++;
                  break;
      } 
    if ( i <= 0 ) { buf[0] = 0; shut = '\n'; }
    } 
  } 

*/  /* END of old readln .. no longer used, included from readln.c */

orc_mode_safe   ( pointer ) char *pointer; {}
orc_mode_unsafe ( pointer ) char *pointer; {}
orc_xmit_general ( s, buf ) int s; char *buf; {}
orc_xmit_private ( s, who, what ) int s; char *who, *what; {}
orc_vadd ( who, where ) char *who, *where; {}
orc_vsub ( who, where ) char *who, *where; {}
orc_vsave( which ) char *which; {}
orc_share_offer ( s, who ) int s; char *who; {}
orc_share_okay  ( s, who ) int s; char *who; {}
orc_share_not   ( s, who ) int s; char *who; {}

int quit(void) 
{ 
  free  ( chunkoram ); 
  close ( s );
  printf ("[=Exiting=]\n");
  sttyinputreset();
  exit(0);
}
